// Sock2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Sock2.h"
#include <winsock2.h>
#include <Ws2tcpip.h>
#include <conio.h>

#pragma comment(lib,"ws2_32")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "FwSocket2.h"

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;


class CSrv : public CFwSocket2 {
	DECLARE_DYNCREATE(CSrv)

	CSrv() {
		SetMaxRecvSilence(100);
	}

	virtual void OnConnectFin(int iErrorCode) {
		printf("+ OnConnectFin() %.3f\t \n", GetTickCount()/100.0f);
		if (iErrorCode) {
			printf("+ Error %d\n", iErrorCode);
		}

	}
	virtual void OnDisconnect(int iErrorCode) {
		printf("- OnDisconnect() %.3f\t \n", GetTickCount()/100.0f);
	}

	virtual void OnDataReceiveFin()
	{
		InBufferLock();
		UINT uNum=GetInBuffer().Len();
		printf("* \"%s\"\n",GetInBuffer().Buf());
		InBufferDel(uNum);
		InBufferUnlock();
	}

	virtual BOOL OnSilenceTimeout()
	{
		printf("Timeout reached\n");
		return TRUE;
	}
};

IMPLEMENT_DYNCREATE(CSrv,CObject)


int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	// initialize MFC and print and error on failure
	AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0);

	int i;
	CFwSocket2 sock;

	DWORD dwTick=GetTickCount();


	const int iMaxSockets=20;
	
	if (argc<2) {

		CFwSocket2 socka[iMaxSockets];

		for (i=0; i<10000; i++) {
			printf("%04d\n",i);

			for (int j=0; j<iMaxSockets; j++) {
				BOOL bRes=socka[j].Connect("127.0.0.1",23);
				if(!bRes) printf("Failed to connected...\n");
			}

			for (j=0; j<iMaxSockets; j++) {
				socka[j].Disconnect();
			}

		}
		printf("\n\nTime=%u milliseconds\n",GetTickCount()-dwTick);
	} else {
		sock.Server(23,RUNTIME_CLASS(CSrv));
	}


	return 0;
	
}
